﻿package
{
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import MY_DragDrop;
	import BL;
	import BR;
	import BM;
	import TL;
	import TR;
	import TM;
	
	public class MY_DragGame extends MovieClip
	{
		private var bl:BL;
		private var br:BR;
		private var bm:BM;
		private var tl:TL;
		private var tr:TR;
		private var tm:TM;
		private var _totalPieces:Number;
		private var _currentPieces:Number;
		
		public function MY_DragGame()
		{
			_totalPieces = 6;
			_currentPieces = 0;
			createPieces();
		}
		
		private function createPieces():void
		{
			bl = new BL();
			addChild(bl);
			bl._targetPiece = blt_mc;
			bl.addEventListener(MouseEvent.MOUSE_UP, checkTarget);
			randomPosition(bl);
			br = new BR();
			addChild(br);
			br._targetPiece = brt_mc;
			br.addEventListener(MouseEvent.MOUSE_UP, checkTarget);
			randomPosition(br);
			bm = new BM();
			addChild(bm);
			bm._targetPiece = bmt_mc;
			bm.addEventListener(MouseEvent.MOUSE_UP, checkTarget);
			randomPosition(bm);
			tl = new TL();
			addChild(tl);
			tl._targetPiece = tlt_mc;
			tl.addEventListener(MouseEvent.MOUSE_UP, checkTarget);
			randomPosition(tl);
			tr = new TR();
			addChild(tr);
			tr._targetPiece = trt_mc;
			tr.addEventListener(MouseEvent.MOUSE_UP, checkTarget);
			randomPosition(tr);
			tm = new TM();
			addChild(tm);
			tm._targetPiece = tmt_mc;
			tm.addEventListener(MouseEvent.MOUSE_UP, checkTarget);
			randomPosition(tm);
		}
		
		private function checkTarget(event:MouseEvent):void
		{
			if(event.currentTarget.hitTestObject(event.currentTarget._targetPiece))
			{
				event.currentTarget.x = event.currentTarget._targetPiece.x;
				event.currentTarget.y = event.currentTarget._targetPiece.y;
				event.currentTarget.removeEventListener(MouseEvent.MOUSE_UP, checkTarget);
				event.currentTarget.disable();
				_currentPieces ++;
				if(_currentPieces >= _totalPieces)
				{
					trace("you win!");
				}
			}
			else
			{
				event.currentTarget.x = event.currentTarget._origX;
				event.currentTarget.y = event.currentTarget._origY;
			}
		}
		
		private function randomPosition(piece:*):void
		{
			piece.x = Math.round(Math.random() * (225 - piece.width));
			piece.y = Math.round(Math.random() * (400 - piece.height));
			piece._origX = piece.x;
			piece._origY = piece.y;
		}
	}
}



//starts 12-2
//need to import both the MY_DragDrop class and the individual puzzle piece class to reference them in AS file
//private var b1:BL; creates a b1 variable
//private function createPieces():void - function that creates the pieces
//private var b1:BL; make the b1 variable a new instance of BL class (same for other pieces)
//addchild(bl); - actually add the b1 piece to the display (same for other pieces)
//createPieces(); - runs the createPieces() function when the MY_DragGame doc class is called when the movie loads

//starts 12-3
//now we need to associate the puzzle pieces with it's target pieces within the createPieces() function
//b1._targetPiece = blt_mc;
	//target piece property for b1 piece is now set to blt target piece
//b1.addEventListener(MouseEvent.MOUSE_UP, checkTarget);
	//added an event listener that triggers the checkTarget() event 
	
//after adding all the mouse events we have to import the definition so Flash knows what to do with them
//private function checkTarget(event:MouseEvent):void 
	//the checkTarget() event handler is crucial to the code
	//it detects if the puzzle piece dropped matches the target piece area
//if(event.currentTarget.hitTestObject(event.currentTarget._targetPiece))
	//tests if the two (puzzle piece and target piece are touching
	//crucial piece is hitTestObject()
		//determines whether a obect is touching or hitting another object passed in through the parentheses
		//event.currentTarget is the puzzle piece the user will have just released
		//event.currentTarget._targetPiece is the puzle piece's related target piece
			//we defined this in b1._targetPiece = blt_mc; and b1.addEventListener(MouseEvent.MOUSE_UP, checkTarget); etc..
			
//starts 12-4
//event.currentTarget.x = event.currentTarget._targetPiece.x; and event.currentTarget.y = event.currentTarget._targetPiece.y;
	//resides in the if conditional statement that checks for matches
	//if there is a match the X and Y positions of currentTarget, the puzzle piece that's dropped snap into place of the target piece
//the else statement will trigger if the conditions of the if statement are not meet (the user does not match the puzzle piece to the target piece)
	//in other words the nonmatching pieces ill snap back to the pile on the left side of the stage
//event.currentTarget.removeEventListener(MouseEvent.MOUSE_UP, checkTarget);
	//turns off the event listener so that the piece will no longer respond to Mouse_Up events
//event.currentTarget.disable();
	//runs the disable() function from the MY_DragDrop.as (this is possible because we made the function public in MY_DragDrop for just this purpose)
	
//starts 12-5
//Detecting a Win
//private var _totalPieces:Number;  and  private var _currentPieces:Number;
	//create two variables to hold the total possible matches 
//_totalPieces = 6; and _currentPieces = 0;
	//the number of current matches the user has made
	//sets initial values of totalPieces and currentPieces
	//put in the constructor function which runs as soon as the doc class is loaded at run time
	//this sets the initial values immediately because there are 6 puzzle pieces which makes 6 total possible matches
	//therefore, currentPieces is 0 at the initial start of the game
//_currentPieces ++;
	//add to _currentPieces variable every time a piece is dropped in the right place
	//A match is detected in the if statement at the bootom of the code
	//therefore, it's appropriate to add the _currentPieces after the matches
//if(_currentPieces >= _totalPieces)
	//you can use two equals signs here
		//but you can use the greater than or equal to just incase you add more pieces
	//conditional statement that runs if the possible matches are greater or equal to the total matches
	//compares _currentPieces to _total pieces so that flash can detect when there is a win
	
//starts 12-7
//private function randomPosition(place:*):void
	//randomize the placement of the puzzle pieces
	//piece variable will be passed into the function as soon as each instance is created
//piece.x =Math.round(Math.random() * (225 - piece.width));
	//randomizes the pieces of the puzzle so that they don't overlap the hit areas of the rectangle
	//* (225 - piece.width));
		// Subtracting the width of the piece ensures they will stay on the left side of the Stage
	//piece.y = Math.round(Math.random() * (400 - piece.height));
		//400 is the height of the stage (subracts the height of the stage from the piece height)
//randomPosition(b1); , etc.
	//calling the random function for each piece
//piece._origX = piece.x; and piece._origY = piece.y;
	//resets the original X and Y variables to the random position values that are generated after the firt two line of codes run